
function plot4d_to_color(X, Y, MARKERSIZE, MAX_COLOR)

    if (size(Y, 2) ~= 1),
        disp('PLOT4D_TO_COLOR: Y have to be a column vector');
    end;
    if (size(X, 2) ~= 3),
        disp('PLOT4D_TO_COLOR: X have to be a 3-column matrix');
    end;
    if (size(X, 1) ~= size(Y,1)),
        disp('PLOT4D_TO_COLOR: X and Y must have the same number rows');
    end;
    
    if (nargin < 3),
        MARKERSIZE = 1;
    end;
    if (nargin < 4),
        MAX_COLOR = 128;
    end;
    
    % building a mapping between Y values and colors
    MAX_COLOR = 128;
    P = [0 min(Y):(max(Y)-min(Y))/(MAX_COLOR-1):max(Y)];
    color_map =  jet(MAX_COLOR);
    
    figure; hold on;
    for i = 1:MAX_COLOR,
        % find the point in the appropriate range of Y values
        ind = find(Y>P(i) & Y<=P(i+1));
        
        % plot the points
        plot3(X(ind,1), X(ind,2), X(ind,3), '.',...
              'MarkerSize', MARKERSIZE, 'Color', color_map(i,:));
    end;    
    grid on;
    colormap(color_map);
    h = colorbar; 
    
    if verLessThan('matlab', '8.5'),
        set(h, 'YTick', linspace(1, length(P), 8), 'YTickLabel', round(P(round(linspace(1, length(P), 8)))), 'FontSize', 12);
    else
        set(h, 'YTick', 0:1/7:1,...
        'YTickLabel', round(P(1):(P(end)-P(1))/7:P(end)), 'FontSize', 12);
    %set(h, 'YTick', [0 1], 'YTickLabel', [P(1) P(end)], 'FontSize', 12);
    end;
    view(-45,20);
    